// Auto-generated. Do not edit!

// (in-package dbw_fca_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class BrakeInfoReport {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.brake_pc = null;
      this.brake_torque_request = null;
      this.brake_torque_actual = null;
      this.brake_pressure = null;
      this.stationary = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('brake_pc')) {
        this.brake_pc = initObj.brake_pc
      }
      else {
        this.brake_pc = 0.0;
      }
      if (initObj.hasOwnProperty('brake_torque_request')) {
        this.brake_torque_request = initObj.brake_torque_request
      }
      else {
        this.brake_torque_request = 0.0;
      }
      if (initObj.hasOwnProperty('brake_torque_actual')) {
        this.brake_torque_actual = initObj.brake_torque_actual
      }
      else {
        this.brake_torque_actual = 0.0;
      }
      if (initObj.hasOwnProperty('brake_pressure')) {
        this.brake_pressure = initObj.brake_pressure
      }
      else {
        this.brake_pressure = 0.0;
      }
      if (initObj.hasOwnProperty('stationary')) {
        this.stationary = initObj.stationary
      }
      else {
        this.stationary = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type BrakeInfoReport
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [brake_pc]
    bufferOffset = _serializer.float32(obj.brake_pc, buffer, bufferOffset);
    // Serialize message field [brake_torque_request]
    bufferOffset = _serializer.float32(obj.brake_torque_request, buffer, bufferOffset);
    // Serialize message field [brake_torque_actual]
    bufferOffset = _serializer.float32(obj.brake_torque_actual, buffer, bufferOffset);
    // Serialize message field [brake_pressure]
    bufferOffset = _serializer.float32(obj.brake_pressure, buffer, bufferOffset);
    // Serialize message field [stationary]
    bufferOffset = _serializer.bool(obj.stationary, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type BrakeInfoReport
    let len;
    let data = new BrakeInfoReport(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [brake_pc]
    data.brake_pc = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [brake_torque_request]
    data.brake_torque_request = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [brake_torque_actual]
    data.brake_torque_actual = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [brake_pressure]
    data.brake_pressure = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [stationary]
    data.stationary = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    return length + 17;
  }

  static datatype() {
    // Returns string type for a message object
    return 'dbw_fca_msgs/BrakeInfoReport';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'e1e5b227493d8bf7e93b1e279d47ff87';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    Header header
    
    # Brake pedal
    float32 brake_pc   # Brake pedal percent, range 0 to 1
    
    # Brake torques (Nm)
    float32 brake_torque_request
    float32 brake_torque_actual
    
    # Brake pressure (bar)
    float32 brake_pressure
    
    # Misc
    bool stationary
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new BrakeInfoReport(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.brake_pc !== undefined) {
      resolved.brake_pc = msg.brake_pc;
    }
    else {
      resolved.brake_pc = 0.0
    }

    if (msg.brake_torque_request !== undefined) {
      resolved.brake_torque_request = msg.brake_torque_request;
    }
    else {
      resolved.brake_torque_request = 0.0
    }

    if (msg.brake_torque_actual !== undefined) {
      resolved.brake_torque_actual = msg.brake_torque_actual;
    }
    else {
      resolved.brake_torque_actual = 0.0
    }

    if (msg.brake_pressure !== undefined) {
      resolved.brake_pressure = msg.brake_pressure;
    }
    else {
      resolved.brake_pressure = 0.0
    }

    if (msg.stationary !== undefined) {
      resolved.stationary = msg.stationary;
    }
    else {
      resolved.stationary = false
    }

    return resolved;
    }
};

module.exports = BrakeInfoReport;
