// Auto-generated. Do not edit!

// (in-package dbw_fca_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let GearNum = require('./GearNum.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class ThrottleInfoReport {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.throttle_pc = null;
      this.axle_torque = null;
      this.gear_num = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('throttle_pc')) {
        this.throttle_pc = initObj.throttle_pc
      }
      else {
        this.throttle_pc = 0.0;
      }
      if (initObj.hasOwnProperty('axle_torque')) {
        this.axle_torque = initObj.axle_torque
      }
      else {
        this.axle_torque = 0.0;
      }
      if (initObj.hasOwnProperty('gear_num')) {
        this.gear_num = initObj.gear_num
      }
      else {
        this.gear_num = new GearNum();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ThrottleInfoReport
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [throttle_pc]
    bufferOffset = _serializer.float32(obj.throttle_pc, buffer, bufferOffset);
    // Serialize message field [axle_torque]
    bufferOffset = _serializer.float32(obj.axle_torque, buffer, bufferOffset);
    // Serialize message field [gear_num]
    bufferOffset = GearNum.serialize(obj.gear_num, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ThrottleInfoReport
    let len;
    let data = new ThrottleInfoReport(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [throttle_pc]
    data.throttle_pc = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [axle_torque]
    data.axle_torque = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [gear_num]
    data.gear_num = GearNum.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    return length + 9;
  }

  static datatype() {
    // Returns string type for a message object
    return 'dbw_fca_msgs/ThrottleInfoReport';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '798c8786d1f3b979755a689dbf8dc2be';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    Header header
    
    # Throttle Pedal
    float32 throttle_pc   # Throttle pedal percent, range 0 to 1
    
    # Engine
    float32 axle_torque   # Driver Intended Axle Torque (Nm)
    
    # Gear Num
    GearNum gear_num      # Gear Number
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: dbw_fca_msgs/GearNum
    uint8 num
    
    uint8 NONE=0
    uint8 DRIVE_D01=1
    uint8 DRIVE_D02=2
    uint8 DRIVE_D03=3
    uint8 DRIVE_D04=4
    uint8 DRIVE_D05=5
    uint8 DRIVE_D06=6
    uint8 DRIVE_D07=7
    uint8 DRIVE_D08=8
    uint8 DRIVE_D09=9
    uint8 DRIVE_D10=10
    uint8 NEUTRAL=16
    uint8 REVERSE_R01=17
    uint8 REVERSE_R02=18
    uint8 PARK=31
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ThrottleInfoReport(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.throttle_pc !== undefined) {
      resolved.throttle_pc = msg.throttle_pc;
    }
    else {
      resolved.throttle_pc = 0.0
    }

    if (msg.axle_torque !== undefined) {
      resolved.axle_torque = msg.axle_torque;
    }
    else {
      resolved.axle_torque = 0.0
    }

    if (msg.gear_num !== undefined) {
      resolved.gear_num = GearNum.Resolve(msg.gear_num)
    }
    else {
      resolved.gear_num = new GearNum()
    }

    return resolved;
    }
};

module.exports = ThrottleInfoReport;
